/* (c) Sinelabore Software Tools GmbH - All rights reserved. Reproduction, modification,
   use or disclosure to third parties without express
   authority is forbidden. Generator running in demo mode!
   Please purchase a license if you want to use this software in projects.
 */

/* Command line options: -l cx -v -p ASTAH -o generated\oven -t final:oven:machine oven_model.asta   */
/* This file is generated from oven_model.asta - do not edit manually */
/* Generated on: Fri Sep 11 16:28:03 CEST 2020 / version 4.3 */




#ifndef __OVEN_DBG_H__
#define __OVEN_DBG_H__

/* State names */
const char oven_states[]=
	"Error\0Idle\0Cooking\0CookingPause\0Completed\0Super\0__OVEN_LAST_STATE__\0";


/* State values */
const unsigned short oven_state_values[]={
	Error,Idle,Cooking,CookingPause,Completed,Super,__OVEN_LAST_STATE__
};


#define InnermostStates "Error,Idle,Cooking,CookingPause,Completed;"
const unsigned short oven_state_idx[]={
	0,6,11,19,32,42,48,68};

#define OVEN_EVENT_START 0


/* Event names */
const char oven_events[]=
	"evTimeout\0evDec\0evDoorOpen\0evDoorClosed\0evInc\0evPwr\0NO_MSG\0";


/* Event values */
const unsigned short oven_event_values[]={
	evTimeout,evDec,evDoorOpen,evDoorClosed,evInc,evPwr,OVEN_NO_MSG
};


/* Helper to map event enum value to an index starting from 0 */
/* Needed if the event enum value is not just 0,1,2,... */
unsigned short oven_map_event_enum(unsigned short evt){
	unsigned short i;
	for(i=0; i<6;i++){
		if(oven_event_values[i]==evt) return i;
	}
	return 6; // should never be reached
}


/* Helper to map state enum value to an index starting from 0 */
/* Needed if the event enum value is not just 0,1,2,... */
unsigned short oven_map_state_enum(unsigned short state){
	unsigned short i;
	for(i=0; i<6;i++){
		if(oven_state_values[i]==state) return i;
	}
	return 6; // should never be reached
}



const unsigned short oven_evt_idx[]={
	0,10,16,27,40,46,52
};

const char* ovenGetNameByState(unsigned short state){
	unsigned short idx = oven_map_state_enum(state);
	return oven_states+oven_state_idx[idx];
}

const char* ovenGetNameByEvent(OVEN_EVENT_T evt){
	unsigned short idx = oven_map_event_enum(evt);
	return oven_events+oven_evt_idx[idx];
}


#endif
