//
// (C) Peter Mueller, sinelabore.com
//  
// This simple program simulates a microwave oven.
// The oven is based on a state machine and an activity diagram
// The code from the UML model is fully generated.
// The main function reads the keyboard and sends events to the state machine.
// A simple "timer" is used as time base.
//
//

#include <time.h>
#include <iostream>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include <windows.h> 
#include <conio.h>

extern "C"
{
	#include "generated/oven_ext.h"
	#include "generated/oven.h"
	#include "helpers/oven_hlp.h"

	OVEN_INSTANCEDATA_T instData = OVEN_INSTANCEDATA_INIT;

	// parameter
	T_PWR pwr = PWR_LOW;

	// message to state machine
	OVEN_EVENT_T msg;


}



int main(int argc, char* argv[]) {

	uint8_t timer_status;

	//
	// interactive mode
	//
	//init_keyboard();
	printf("This is the simulation of a simple microwave oven.\n");
	printf("Use '+' for increment the cooking time; '-' for decrement the cooking time\n");
	printf("'o' for open and 'c' for close the door\n");
	printf("Use 'p' to set medium power; 'P' to set high power\n");
	printf("Try '+' '+' '+' to set a time and then close the door with 'c' to start cooking\n");
	printf("Take a look into the state machine diagram and check what else is possible\n");
	printf("If you find gaps in the design - modify and recreate the code\n");
	do {
		Sleep(100); // sleep 100ms
		timer_status = tick();

		if (timer_status) {
			msg = evTimeout;
		}
		else if (_kbhit()) {
			char ch = _getch();
			if (ch == '+')
				msg = evInc;
			else if (ch == '-')
				msg = evDec;
			else if (ch == 'c')
				msg = evDoorClosed;
			else if (ch == 'o')
				msg = evDoorOpen;
			else if (ch == 'q') {
				exit(0);
			}
			else if (ch == 'P') {
				pwr = PWR_HIGH;
				msg = evPwr;
			}
			else if (ch == 'p') {
				pwr = PWR_LOW;
				msg = evPwr;
			}
			else {
				printf("Unknown key. Use + for inc; - for dec; o for open and c for close.\n");
				printf("             Use 'p' to set medium power; 'P' to set high power\n");
				msg = OVEN_NO_MSG;
			}
		}
		else {
			msg = OVEN_NO_MSG;
		}

		oven(&instData);

	} while (true);

	return 0;
}